pragma Source_Reference( 1,"aenea/aenea-db.adq");
 ------------------------------------------------------------------------------ 
 --                         ADAGIO - ADALID - AENEA.                         -- 
 --                                                                          -- 
 --                            Copyright (C) 2003                            -- 
 --                                 A. Mosteo.                               -- 
 --                                                                          -- 
 --  Authors: A. Mosteo. (adagio@mosteo.com)                                 -- 
 --                                                                          -- 
 --  If you have any questions in regard to this software, please address    -- 
 --  them to the above email.                                                -- 
 --                                                                          -- 
 --  This program is free software; you can redistribute it and/or modify    -- 
 --  it under the terms of the GNU General Public License as published by    -- 
 --  the Free Software Foundation; either version 2 of the License, or (at   -- 
 --  your option) any later version.                                         -- 
 --                                                                          -- 
 --  This program is distributed in the hope that it will be useful, but     -- 
 --  WITHOUT ANY WARRANTY; without even the implied warranty of              -- 
 --  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       -- 
 --  General Public License for more details.                                -- 
 --                                                                          -- 
 --  You should have received a copy of the GNU General Public License       -- 
 --  along with this library; if not, write to the Free Software Foundation, -- 
 --  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.          -- 
 --                                                                          -- 
 --  You are not allowed to use any part of this code to develop a program   -- 
 --  whose output would be used to harass or prosecute other users of the    -- 
 --  networks Adagio connects with. All data collected with Adagio or a tool -- 
 --  containing Adagio code about other network users must remain            -- 
 --  confidential and cannot be made public by any mean, nor be used to      -- 
 --  harass or legally prosecute these users.                                -- 
 ------------------------------------------------------------------------------ 
 --  $Id: aenea-db.adb,v 1.23 2004/03/22 07:14:55 Jano Exp $ 
  with Aenea.Net;
 with Aenea.Trace;
  with Sql_standard; use Sql_standard;
with Ada.Exceptions;            use Ada.Exceptions;
with Ada.Characters.Latin_1;    use Ada.Characters;
WITH GNU.DB.ESQL_ISO92_TYPES;   USE GNU.DB.ESQL_ISO92_TYPES;
WITH GNU.DB.ESQL_SUPPORT;       USE GNU.DB.ESQL_SUPPORT;
WITH GNU.DB.ESQL_SUPPORT.ODBC; 
USE  GNU.DB.ESQL_SUPPORT.ODBC; 
USE  GNU.DB.ESQL_SUPPORT;
WITH GNU.DB.SQLCLI;
USE  GNU.DB;

pragma Elaborate_All(GNU.DB.ESQL_SUPPORT.ODBC);

pragma Source_Reference( 40,"aenea/aenea-db.adq");


  package body Aenea.Db is
   SQLCODE          : SQL_STANDARD.SQLCODE_TYPE ;
   SQLSTATE         : SQL_STANDARD.SQLSTATE_TYPE;
   SQLCA            : aliased ESQL_SUPPORT.SQLCA_TYPE;
   
   GNADE_DB_DEFAULT : ODBC.CONNECTION_HANDLE := NULL;
   GNADE_G_CONTEXT  : ODBC.CONTEXT_TYPE;
   
     -- Database 
   GNADE_DB_DB : ODBC.CONNECTION_HANDLE
;
     ------------------------------------------------------------------------ 
    -- Init                                                               -- 
    ------------------------------------------------------------------------ 
    procedure Init is
    begin
              -- Connect 
      begin
         GNADE_DB_DB:=ODBC.Connect("hyperion", "", "");
         
      end;
pragma Source_Reference( 54,"aenea/aenea-db.adq");
        Trace.Log ("Connection with database successful.", Trace.Informative);
    end Init;
     ------------------------------------------------------------------------ 
    -- Insert_row                                                         -- 
    ------------------------------------------------------------------------ 
    procedure Insert_row (Hubs, Leaves, Tracked : in Natural) is
      
         GNADE_L_CONTEXT : ODBC.CONTEXT_TYPE;
       Hubss, Leavess, Trackedd : INT;
pragma Source_Reference( 67,"aenea/aenea-db.adq");
    begin
       Hubss    := INT (Hubs);
       Leavess  := INT (Leaves);
       Trackedd := INT (Tracked);
        -- UGLY HACK UNTIL I DISCOVER WHAT IS WRONG WITH THE INSERTION 
         begin
            GNADE_DB_DB:=ODBC.Connect("hyperion", "", "");
            
         end;
pragma Source_Reference( 74,"aenea/aenea-db.adq");
--% aenea/aenea-db.adq at 78 : *** Query ***
         declare
            Hubss_Indicator : aliased SQL_STANDARD.INDICATOR_TYPE := 0;
            Leavess_Indicator : aliased SQL_STANDARD.INDICATOR_TYPE := 0;
            Trackedd_Indicator : aliased SQL_STANDARD.INDICATOR_TYPE := 0;
         begin
            -- Prepare
            ODBC.PREPARE(GNADE_DB_DB,
               GNADE_G_CONTEXT,
               " insert INTO g2crawl( hubs, leaves, tracked, fecha) values(?" &
               " ,? ,? , Now())",
               SQLCA'Address,
               Is_Reopenable =>FALSE);
            -- Evaluate_Result
            SQLCODE  := SQLCA.SQLCODE;
            SQLSTATE := SQLCA.STATE;
            IF ( SQLSTATE(1..2) /= ESQL_SUPPORT.SUCCESS_CLASS  AND
               SQLSTATE(1..2) /= ESQL_SUPPORT.WARNING_CLASS  AND 
               SQLSTATE(1..2) /= ESQL_SUPPORT.NOTFOUND_CLASS)  OR
               SQLCODE in SQL_STANDARD.SQL_ERROR THEN
               Raise_Exception(DB_Error'Identity,
                 "Line 76 in package Aenea.Db : Prepare Query failed " &  Latin_1.LF & SQLCA.message);
            END IF;
            -- Parameter Binding Hubss                                           
            ODBC.BINDPARAMETER(
                   GNADE_DB_DB,
                    1,
                   Hubss'Address,
                   Hubss'Size,
                   ISO92_INT_TYPE,
                   Hubss_Indicator'Access
                   
               );
            -- Parameter Binding Leavess                                         
            ODBC.BINDPARAMETER(
                   GNADE_DB_DB,
                    2,
                   Leavess'Address,
                   Leavess'Size,
                   ISO92_INT_TYPE,
                   Leavess_Indicator'Access
                   
               );
            -- Parameter Binding Trackedd                                        
            ODBC.BINDPARAMETER(
                   GNADE_DB_DB,
                    3,
                   Trackedd'Address,
                   Trackedd'Size,
                   ISO92_INT_TYPE,
                   Trackedd_Indicator'Access
                   
               );
            -- Execute
            ODBC.EXECUTE(GNADE_DB_DB,SQLCA'Address);
            -- Evaluate_Result
            SQLCODE  := SQLCA.SQLCODE;
            SQLSTATE := SQLCA.STATE;
            IF ( SQLSTATE(1..2) /= ESQL_SUPPORT.SUCCESS_CLASS  AND
               SQLSTATE(1..2) /= ESQL_SUPPORT.WARNING_CLASS  AND 
               SQLSTATE(1..2) /= ESQL_SUPPORT.NOTFOUND_CLASS)  OR
               SQLCODE in SQL_STANDARD.SQL_ERROR THEN
               Raise_Exception(DB_Error'Identity,
                 "Line 76 in package Aenea.Db :  Query  failed " &  Latin_1.LF & SQLCA.message);
            END IF;
            exception
               when The_Error : Others =>
            ESQL_SUPPORT.DEBUG(
               "Line 76 in package Aenea.Db : *** Exception in query ****",
               "",
               SQLCA'Address);
            
                  raise;
         end;
pragma Source_Reference( 78,"aenea/aenea-db.adq");
--% aenea/aenea-db.adq at 80 : *** Query ***
         begin
            -- Prepare
            -- Execute
            ODBC.EXECUTE(GNADE_DB_DB,SQLCA'Address, 
               Statement => " COMMIT");
            -- Evaluate_Result
            SQLCODE  := SQLCA.SQLCODE;
            SQLSTATE := SQLCA.STATE;
            exception
               when The_Error : Others =>
            ESQL_SUPPORT.DEBUG(
               "Line 80 in package Aenea.Db : *** Exception in query ****",
               "",
               SQLCA'Address);
            
                  raise;
         end;
pragma Source_Reference( 80,"aenea/aenea-db.adq");
        -- UGLY HACK UNTIL I DISCOVER WHAT IS WRONG WITH THE INSERTION 
         ODBC.DISCONNECT(GNADE_DB_DB,GNADE_G_CONTEXT,Commit => FALSE);
pragma Source_Reference( 83,"aenea/aenea-db.adq");
     exception
       when E : DB_Error =>
          Trace.Log ("Database insertion failed: " & Trace.Report (E),
             Trace.Error);
       when E : others =>
          Trace.Log ("Database insertion failed: " & Trace.Report (E),
             Trace.Error);
    end Insert_row;
     end Aenea.Db;
--% aenea/aenea-db.adq at 95 : ***************************************************
--% aenea/aenea-db.adq at 95 :         !!!  D O   N O T   E D I T   !!! 
--% aenea/aenea-db.adq at 95 :  This file is gnerated by GNADE ESQL translator 
--% aenea/aenea-db.adq at 95 : 
--% aenea/aenea-db.adq at 95 :  ESQL VERSION : 1.4.3a
--% aenea/aenea-db.adq at 95 :  SOURCE FILE  : aenea/aenea-db.adq
--% aenea/aenea-db.adq at 95 :  OPTIONS      : 
--% aenea/aenea-db.adq at 95 :      aenea/aenea-db.adq
--% aenea/aenea-db.adq at 95 : ***************************************************
